VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.2#0"; "COMCTL32.OCX"
Begin VB.Form frmImgHeader 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Exemple d'image dans les ttes de colonnes..."
   ClientHeight    =   3195
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5700
   Icon            =   "ImgHeader.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   5700
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdHeaderHotTrack 
      Caption         =   "Changer la couleur au passage de la souris"
      Height          =   735
      Left            =   4080
      TabIndex        =   4
      Top             =   1440
      Width           =   1575
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Effacer"
      Height          =   375
      Left            =   4080
      TabIndex        =   3
      Top             =   960
      Width           =   1575
   End
   Begin VB.CommandButton cmdAddHeaderPics 
      Caption         =   "Ajouter une image  la deuxime colonne"
      Height          =   735
      Left            =   4080
      TabIndex        =   2
      Top             =   120
      Width           =   1575
   End
   Begin VB.CheckBox chkImgPosition 
      Caption         =   "Centr"
      Height          =   195
      Left            =   720
      TabIndex        =   1
      Top             =   2880
      Width           =   1095
   End
   Begin ComctlLib.ListView ListView1 
      Height          =   2535
      Left            =   720
      TabIndex        =   0
      Top             =   120
      Width           =   3255
      _ExtentX        =   5741
      _ExtentY        =   4471
      View            =   3
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   327682
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Copyright (c) 1998 Antoine FRACK"
      Height          =   195
      Left            =   3120
      TabIndex        =   5
      Top             =   2880
      Width           =   2445
   End
   Begin ComctlLib.ImageList ImageList1 
      Left            =   0
      Top             =   960
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   13
      ImageHeight     =   13
      MaskColor       =   16777215
      _Version        =   327682
      BeginProperty Images {0713E8C2-850A-101B-AFC0-4210102A8DA7} 
         NumListImages   =   2
         BeginProperty ListImage1 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "ImgHeader.frx":000C
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "ImgHeader.frx":0266
            Key             =   ""
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "frmImgHeader"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'--------------------------------------------------
'NOM         : ImgHeader
'AUTEUR      : Antoine FRACK
'                   afrack@wanadoo.fr
'                   http://www.mygale.org10/afrack/
'DATE        : dimanche 19 avril
'LICENCE     : ce logiciel est mis dans le domaine public
'--------------------------------------------------
'Cet exemple vous montre comment mettre des images
'dans l'en-tte d'une listview

    
Private bState As Boolean
Private imgPosition As Long


Private Sub chkImgPosition_Click()

   If chkImgPosition Then
         imgPosition = HDF_BITMAP_ON_RIGHT
   Else: imgPosition = HDF_BITMAP
   End If
   
End Sub


Private Sub cmdAddHeaderPics_Click()
    
  'ajouter une image  une colonne spcifie
  'syntaxe:
  'ShowHeaderIcon No_Colonne, No_ImageList, Justification, image flag
  
   ShowHeaderIcon 1, 0, imgPosition, HDF_IMAGE

  'dsactive la bote  cocher
   chkImgPosition.Enabled = False

End Sub


Public Sub ShowHeaderIcon(colNo As Long, imgIconNo As Long, _
                          justify As Long, showImage As Long)

   Dim r As Long
   Dim hHeader As Long
   Dim HD As HD_ITEM
   
  'rcupre le handle des ttes de colonnes
   hHeader = SendMessageLong(ListView1.hwnd, LVM_GETHEADER, 0, 0)
   
  'installe la structure requise
   With HD
      .mask = HDI_IMAGE Or HDI_FORMAT
      .fmt = HDF_LEFT Or HDF_STRING Or justify Or showImage
      .pszText = ListView1.ColumnHeaders(colNo + 1).Text
      If showImage Then .iImage = imgIconNo
   End With
   
  'modifie l'en-tte
   r = SendMessageAny(hHeader, HDM_SETITEM, colNo, HD)
   
End Sub


Public Sub SetHeaderHotTrack()

   Dim r As Long
   Dim hHeader As Long
   Dim rstyle As Long
   
  'rcupre le handle des ttes de colonnes
   hHeader = SendMessageLong(ListView1.hwnd, LVM_GETHEADER, 0, 0)
   
  'retrouve le style courant de l'en-tte
   rstyle = GetWindowLong(hHeader, GWL_STYLE)
   
  'alterne les attributs de style
   rstyle = rstyle Xor HDS_HOTTRACK

  'met le style d'en-tte
   r = SetWindowLong(hHeader, GWL_STYLE, rstyle)
   
End Sub


Private Sub cmdClear_Click()

   Dim r As Long
   Dim colNo As Long
   Dim hHeader As Long
   Dim HD As HD_ITEM
   
  'rcupre le handle des ttes de colonnes
   hHeader = SendMessageLong(ListView1.hwnd, LVM_GETHEADER, 0, 0)
   
   For colNo = 0 To ListView1.ColumnHeaders.Count - 1
     
     'applique la structure requise
      With HD
         .mask = HDI_FORMAT
         .fmt = HDF_LEFT Or HDF_STRING
         .pszText = ListView1.ColumnHeaders(colNo + 1).Text
      End With
   
     'modifie l'en-tte de colonnes
      r = SendMessageAny(hHeader, HDM_SETITEM, colNo, HD)
   
   Next colNo
   
   chkImgPosition.Enabled = True

End Sub



Private Sub cmdHeaderHotTrack_Click()

    bState = Not bState
    SetHeaderHotTrack
    
    cmdHeaderHotTrack.Caption = IIf(bState, "Activer", "Dactiver")
    
End Sub


Private Sub Form_Load()

   Dim i As Integer
   Dim itmX As ListItem
   Dim imgX As ListImage
   
  'cre et remplie la liste
   With ListView1
      
      .SmallIcons = ImageList1
      
      For i = 1 To 3
         .ColumnHeaders.Add , "x" & i, "Colonne " & i & Space$(4)
         .ColumnHeaders.Item(i).Width = 1520
      Next i
      
      For i = 1 To 9
         Set itmX = .ListItems.Add(, "key" & i, "choix " & i)
         itmX.SubItems(1) = "col2 " & i
         itmX.SubItems(2) = "col3 " & i
      Next i
      
         
   End With
   
End Sub


Private Sub ListView1_ColumnClick(ByVal ColumnHeader As ComctlLib.ColumnHeader)

   Dim i As Long
   Static sOrder
   
   sOrder = Not sOrder
   
  'utilse la classification par dfaut des lignes
   ListView1.SortKey = ColumnHeader.Index - 1
   ListView1.SortOrder = Abs(sOrder)
   ListView1.Sorted = True
  
  'enlve les images des en-ttes qui ne sont pas
  'classes, et met  jour l'en-tte clique
   For i = 0 To 2
      
     'si c'est l'index le la colonne clique
      If i = ListView1.SortKey Then
      
            ShowHeaderIcon ListView1.SortKey, _
                           ListView1.SortOrder, _
                           imgPosition, _
                           HDF_IMAGE
                           
      Else: ShowHeaderIcon i, 0, 0, 0
      End If
      
   Next
   
End Sub



